describe('HE revokes reviewer invitation while invitation is in pending', () => {
  beforeEach(() => {
    cy.fixture('users/admin').as('admin')
    cy.fixture('users/eic').as('eic')
    cy.fixture('users/he').as('he')
    cy.fixture('users/author').as('author')
    cy.fixture('users/reviewer').as('reviewer')
    cy.fixture('models/fragment').as('fragment')
    cy.fixture('models/updatedFragment').as('updatedFragment')
    cy.fixture('manuscripts/statuses').as('statuses')

    cy.clearLocalStorage()
  })

  it('Successfully submits a manuscript', () => {
    cy.createManuscriptViaAPI()
  })

  it('Invite HE as EiC', function inviteHE() {
    const { eic, he, statuses } = this
    cy.inviteHE({ eic, he })
    cy.checkStatus(statuses.heInvited.editorInChief)

    cy.loginApi(he.username, he.password)
    cy.visit('/')

    cy.get(`[data-test-id="manuscript-${Cypress.env('manuscriptId')}"]`)
      .should('be.visible')
      .click()
    cy.checkStatus(statuses.heInvited.handlingEditor)
  })

  it('Should accept invitation as HE', function respondToInvitationAsHE() {
    const { he } = this
    cy.loginApi(he.email, he.password)
    cy.visit('/')
    cy.get(`[data-test-id="manuscript-${Cypress.env('manuscriptId')}"]`)
      .should('be.visible')
      .click()
    cy.respondToInvitationAsHE('yes')
    cy.wait(4000)
  })

  it('Invite reviewers as HE', function inviteReviewer() {
    const { reviewer, he } = this
    cy.loginApi(he.email, he.password)
    cy.visit('/')
    cy.get(`[data-test-id="manuscript-${Cypress.env('manuscriptId')}"]`).click()
    cy.inviteReviewer({ reviewer, he })
  })

  it('Revoke reviewer invitation while invitation is in pending as HE', function revokeReviewer() {
    const { statuses, reviewer, he } = this
    cy.loginApi(reviewer[1].email, reviewer[1].password)
    cy.visit('/')
    cy.get(`[data-test-id="manuscript-${Cypress.env('manuscriptId')}"]`).click()
    cy.checkStatus(statuses.reviewersInvited.reviewer)

    cy.loginApi(he.email, he.password)
    cy.visit('/')
    cy.get(`[data-test-id="manuscript-${Cypress.env('manuscriptId')}"]`).click()

    cy.checkStatus(statuses.reviewersInvited.handlingEditor)
    cy.get(`div[label="Reviewer Details & Reports"]`)
      .click()
      .contains('PENDING')
      .last()
      .click()
    cy.get('[data-test-id="revoke-icon"]')
      .eq(0)
      .should('be.visible')
      .click()
    cy.get(`[ data-test-id="modal-cancel"]`).click()
    cy.get(`div[label="Reviewer Details & Reports"]`)
      .click()
      .contains('PENDING')
      .last()
      .click()
    cy.get('[data-test-id="revoke-icon"]')
      .eq(1)
      .should('be.visible')
      .last()
      .click()
    cy.get(`[ data-test-id="modal-confirm"]`).click()
    cy.wait(2000)

    cy.get(`div[label="Reviewer Details & Reports"]`)
      .contains('PENDING')
      .last()
      .click()

    cy.get('[data-test-id="revoke-icon"]')
      .eq(1)
      .should('be.visible')
      .last()
      .click()
    cy.get(`[ data-test-id="modal-cancel"]`).click()
    cy.get(`div[label="Reviewer Details & Reports"]`)
      .click()
      .contains('PENDING')
      .last()
      .click()
    cy.get(`[ data-test-id="revoke-icon"]`)
      .eq(1)
      .should('be.visible')
      .last()
      .click()
    cy.get(`[ data-test-id="modal-confirm"]`).click()
    cy.wait(2000)

    cy.get(`div[label="Reviewer Details & Reports"]`)
      .contains('PENDING')
      .last()
      .click()
    cy.get(`[data-test-id="revoke-icon"]`)
      .should('be.visible')
      .last()
      .click()
    cy.get(`[ data-test-id="modal-cancel"]`).click()
    cy.get(`div[label="Reviewer Details & Reports"]`)
      .click()
      .contains('PENDING')
      .last()
      .click()
    cy.get(`[data-test-id="revoke-icon"]`)
      .should('be.visible')
      .last()
      .click()
    cy.get(`[ data-test-id="modal-confirm"]`).click()
    cy.wait(2000)

    cy.get(`div[label="Reviewer Details & Reports"]`)
      .should('be.visible')
      .should('not.contain', 'Reviewer1 Rev1')
      .should('not.contain', 'Revington2 Dude')
      .should('not.contain', 'Revington Dude')
    cy.checkStatus(statuses.heAssigned.handlingEditor)
    cy.loginApi(reviewer[1].email, reviewer[1].password)
    cy.visit('/')
    cy.wait(3000)
    cy.get(`[data-test-id="manuscript-${Cypress.env('manuscriptId')}"]`).should(
      'not.be.visible',
    )
  })
})
